<!-- Copyright (c) Vincent Dardel, <vindarez@mailz.org>,  Abelujo Developers-->
<!-- See the COPYRIGHT file at the top-level directory of this distribution-->
<!-- Abelujo is free software: you can redistribute it and/or modify-->
<!-- it under the terms of the GNU Affero General Public License as published by-->
<!-- the Free Software Foundation, either version 3 of the License, or-->
<!-- (at your option) any later version.-->
<!-- Abelujo is distributed in the hope that it will be useful,-->
<!-- but WITHOUT ANY WARRANTY; without even the implied warranty of-->
<!-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the-->
<!-- GNU Affero General Public License for more details.-->
<!-- You should have received a copy of the GNU Affero General Public License-->
<!-- along with Abelujo.  If not, see <http://www.gnu.org/licenses/>.-->

{% extends "base.html" %}
{% block content %}
{% load bootstrap3 %}
{% bootstrap_css %}
{% bootstrap_javascript %}
{% load i18n %}

<span>
  <!-- We should be able to boost the previous month: no more sells are going-->
  <!-- to be made (should be prohibited), or very very little, so we nearly don't risk-->
  <!-- this page to be out of sync.-->
  <!---->
  <!-- Actually, boost does not preload the page, it does an AJAX call-->
  <!-- and replaces the body.-->
  <!-- So we can boost every month here.-->
  <!---->
  <!-- I tried HTMX's preload extension, but it does not work.-->
  <!-- It does a preload call, but then it does a full page refresh.-->
  <!-- https://github.com/bigskysoftware/htmx/issues/689-->
  <!---->
  <!-- For heavy/slow months, some caching should be done server side.-->

  <a hx-boost="true" href="{% url 'history_sells_month' previous_month %}">
    <button style="margin-bottom: 5px" class="btn btn-default btn-sm">
      &larr; {{ previous_month_obj | date:'F' | capfirst }}
    </button>
  </a><span>&nbsp;
  </span>
</span>
<span style="padding: 5px">
  <span>
    {{ day | date:"F" | capfirst }} {{ day.year }}
  </span>
</span>

{% if  day.year < now.year or day.month < now.month %}
<span>
  {% if  day.year < now.year or next_month_obj.month < now.month %}
  <!-- boost next month.-->
  <a hx-boost="true" href="{% url 'history_sells_month' next_month %}">
    <button class="btn btn-default btn-sm">
      {{ next_month_obj | date:'F' | capfirst }} &rarr;
    </button>
  </a>

  {% else %}

  <!-- allright, "boost" does not preload, so let's boost this too,-->
  <!-- and I'll keep the if logic for preloading, to use next time.-->
  <a hx-boost="true" href="{% url 'history_sells_month' next_month %}">
    <button class="btn btn-default btn-sm">
      {{ next_month_obj | date:'F' | capfirst }} &rarr;
    </button>
  </a>

  {% endif %}

</span>

{% endif %}

<span:form style="margin-left: 1em">
  <select id="month" name="month">
    <option>1</option>
    <option>2</option>
    <option>3</option>
    <option>4</option>
    <option>5</option>
    <option>6</option>
    <option>7</option>
    <option>8</option>
    <option>9</option>
    <option>10</option>
    <option>11</option>
    <option>12</option>
  </select>
  <select id="year" name="year">
    {% for year in years_range %}
    <option>
      {{ year }}
    </option>
    {% endfor %}
  </select>

  {% get_current_language as LANGUAGE_CODE %}

  <button onclick="window.location.pathname = '/{{ LANGUAGE_CODE }}/history/sells/month/' + document.getElementById('year').value + '-' + document.getElementById('month').value" class="btn btn-default btn-sm">&#10004;
  </button>

</span:form>


<a hx-boost="true" style="padding-left: 1em; text-decoration: underline;" href="/{{ LANGUAGE_CODE }}/history/sells/month/">
  {{ now | date:'F' }} {{ now.year }}
</a> &nbsp;&bull;

<a hx-boost="true" style="text-decoration: underline;" href="/{{ LANGUAGE_CODE }}/history/today/">
  {% trans "today" %}
</a>

<div class="row">
  <div class="col-lg-10">
    <ul class="nav nav-tabs">
      <li role="presentation" class="active">
        <a>
	  {% trans "Sells" %}
        </a>
      </li>
      <li role="presentation">
        <a href="{% url 'history_entries_month' day|date:'Y-m'  %}">
	  {% trans "Entries" %}
        </a>
      </li>
    </ul>
  </div>
</div>

<span>
  <span style="font-size: 240%; margin-right: 1em; vertical-align: middle;">
    {{ day | date:'F Y' | title }}
  </span>
  <span>
    <div class="btn-group">
      <div class="dropdown">
        <button type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" class="btn btn-success dropdown-toggle">
	  {% trans "Export" %}
          <span class="caret">
          </span>
        </button>

        <ul class="dropdown-menu">
          <li><a href="/{{ LANGUAGE_CODE }}/history/sells/month/{{day.year}}-{{day.month}}/export?fileformat=txt" title="">
	    {% trans "All sells of this month" %} - txt
	  </a><a href="/{{ LANGUAGE_CODE }}/history/sells/month/{{day.year}}-{{day.month}}/export?fileformat=csv" title="">
	    {% trans "All sells of this month" %} - csv
	  </a>
          <a href="/{{ LANGUAGE_CODE }}/history/sells/month/{{day.year}}-{{day.month}}/export?fileformat=csv&report=totalperday" title="">
	    {% trans "Earnings per day" %} - csv
	  </a>
          <a href="/{{ LANGUAGE_CODE }}/history/sells/month/{{day.year}}-{{day.month}}/export?fileformat=pdf&report=ticketz&lang={{ LANGUAGE_CODE }}" title="">
	    {% trans "Ticket Z" %} - pdf
	  </a>
	  </li>
        </ul>
      </div>
    </div>
  </span>
</span>

<div class="row">
  <div class="col-md-3 panel panel-primary">
    <div class="panel-heading">
      {% trans "Cash register" %}
    </div>
    <div class="panel-body">
      <h4>
	{{ sells_data.total_price_sold_fmt }}
      </h4>
    </div>
  </div>

  <div class="col-md-3 panel panel-primary">
    <div class="panel-heading">
      {% trans "Articles sold" %}
    </div>
    <div class="panel-body">
      <h4>
	{{ sells_data.total_cards_sold }}
      </h4>
    </div>
  </div>

  <div class="col-md-3 panel panel-primary">
    <div class="panel-heading">
      {% trans "Cash register movements" %}
    </div>
    <div class="panel-body">
      <h4>
	{{ sells_data.nb_sells }}
      </h4>
    </div>
  </div>
</div>

<div class="row">
  <div class="col-md-4">
    <table class="table table-striped">

      {% for it in sells_data.data reversed %}
      <tr>
        <td>
	  {% if  it.weekday == 6 %}<span style="color: grey;">
	  {{ it.date_obj | date:'l' }} 
	  </span>
	  {% else %}
          <span>
	    {{ it.date_obj | date:'l' }} 
	  </span>
	  {% endif %}

	</td>
        <td>
          <a href="{% url 'history_sells_day' it.date %}">
	    {{ it.date }}
	  </a>
	</td>
        <td class="text-right">
	  {{ it.total_price_sold_fmt }}
	</td>
      </tr>
      {% endfor %}

    </table>
  </div>

  <div class="col-md-4">
    <h4>
      {% trans "Best sells" %}
    </h4>
    <h5>
      {% trans "Books" %}
    </h5>
    <table class="table">

      {% for it in sells_data.best_sells.book %}
      <tr>
        <td>
          {% if it.0.img %}

          <img src="{{ it.0.img }}" style="max-height: 80px" />

          {% comment %}

            Here the code to make the cover clickable.

            These modals work, but I have an issue: clicking on an image at the bottom
            shows the modal at the top of the page -so it is truncated.

          <a data-toggle="modal"
              data-target="#enlargeImageModal{{ it.0.pk }}"

            <img src="{{ it.0.img }}" style="max-height: 80px" class="img-responsive mouse-pointer"/>

            <!-- enlargeImageModal ci-dessous: -->
            <div id="enlargeImageModal{{ it.0.pk }}" class="modal">
              {% with object=it.0 %}
              {% include "search/modale_enlarge_image.html" %}
              {% endwith %}
            </div>
            {% endcomment %}

            {% endif %}
        </td>
        <td>
          <a href="{{it.0.get_absolute_url}}">
	    {{ it.0.title }}
	  </a>
	</td>
        <td>
	  {{ it.1 }}
	</td>
      </tr>
      {% endfor %}

    </table>
    {% for other in sells_data.best_sells.items %}
    {% if other.0 != 'book' %}
    {% if other.1 %}
    <h5>
      {{ other.0 }}
    </h5>
    <table class="table">

      {% for it in other.1 %}
      <tr>
        <td><a href="{{it.0.get_absolute_url}}">
	  {{ it.0.title }}
	</a>

	</td>
        <td>
	  {{ it.1 }}
	</td>
      </tr>
      {% endfor %}

    </table>
    {% endif %}
    {% endif %}
    {% endfor %}

  </div>

  <div class="col-md-4">
    <div class="row">
      <h4>
	{% trans "Best shelves" %} {{ day | date:"F" | capfirst }} {{ day.year }}
      </h4>
      <div>
        <div class="col-md-12">
          <table class="table table-striped table-condensed">
            <thead class="thead-light">
              <tr>
                <th>
	        </th>
                <th>
	          {% trans "Shelf" %}
	        </th>
                <th>
	        </th>
                <th>
	          {% trans "Revenue" %} {{ default_currency }}
	        </th>
                <th>
	          {% trans "Transactions" %}
	        </th>
                <th>
	        </th>
	      </tr>
	    </thead>

            <tbody>
	      {% if  best_shelves %}{% for data in best_shelves %}
              <tr>
                <td>
	          {{ forloop.counter }}
	        </td>
                <td>
                  <div>
	            {{ data.shelf_name }}
	          </div>
	          {% if  forloop.counter < 6 %}
                  <div style="height: 5px;" class="progress">
                    <div role="progressbar" style="width: {{ data.revenue_percent_string }}%;" aria-valuemax="100" aria-valuemin="0" class="progress-bar bg-info">
	            </div>

	          </div>
	          {% endif %}

	        </td>
                <td class="text-right">
	          {{ data.revenue_percent_fmt }}
	        </td>
                <td class="text-right">
	          {{ data.revenue_fmt }}
	        </td>
                <td class="text-right">
	          {{ data.count }}
	        </td>
                <td class="text-right">
	          {{ data.soldcards_percent_fmt }}
	        </td>

	      </tr>
	      {% endfor %}{% endif %}

	    </tbody>

	  </table>
	  {% if  not best_shelves %}
          <div>
	    {% trans "No data!" %}
	  </div>
	  {% endif %}

	</div>
      </div>
    </div>
  </div>
</div>

{% endblock content %}
